#include "Custom.h"

#define SAFE_RELEASE(p) { if ( (p) ) { (p)->Release(); (p) = 0; }}

//external
extern HINSTANCE hInst;
extern IDirect3DDevice9 *pD3DDevice;

//locals
typedef struct tagQuadVertex {
	D3DXVECTOR3 Position;
	D3DXVECTOR2 Tex;
} QuadVertex;
LPDIRECT3DVERTEXBUFFER9  m_pVertexBuffer = 0;
bool runonce = false;
IDirect3DTexture9* sceneTex = 0;
IDirect3DTexture9* sceneTexDown25 = 0;
unsigned long screen_width = 800;
unsigned long screen_height = 600;
bool bFixedFog = true;
float fogConst = 450.0f;
int screenKey = VK_F7;
unsigned long screenCount = 0;
const static float UBYTERECIP = 1.0f / 255.0f;
ID3DXEffect* g_pEffect = NULL;

unsigned char* gameBlur = (unsigned char*)0x008D5104;
float BlurAmount = 0.0f;//(float*)0x008D5104;

//ingame current timecyc beginning; B7C4A0
#pragma pack(push, 1)
struct igtimecyc {
	float m_fCurrentAmbientRed;
	float m_fCurrentAmbientGreen;
	float m_fCurrentAmbientBlue;
	float m_fCurrentAmbientObjectRed;
	float m_fCurrentAmbientObjectGreen;
	float m_fCurrentAmbientObjectBlue;
	float Unknown1;
	float Unknown2;
	float Unknown3;
	WORD m_nCurrentSkyTopRed;
	WORD m_nCurrentSkyTopGreen;
	WORD m_nCurrentSkyTopBlue;
	WORD m_nCurrentSkyBottomRed;
	WORD m_nCurrentSkyBottomGreen;
	WORD m_nCurrentSkyBottomBlue;
	WORD m_nCurrentSunCoreRed;
	WORD m_nCurrentSunCoreGreen;
	WORD m_nCurrentSunCoreBlue;
	WORD m_nCurrentSunCoronaRed;
	WORD m_nCurrentSunCoronaGreen;
	WORD m_nCurrentSunCoronaBlue;
	float m_fCurrentSunSize;
	float m_fCurrentSpriteSize;
	float m_fCurrentSpriteBrightness;
	WORD m_nCurrentShadowStrength;
	WORD m_nLightShadowStrength;
	WORD m_nPoleShadowStrength;
	char gap_1[2];
	float m_fCurrentFarClip;
	float m_fCurrentFogStart;
	float m_fCurrentLightsOnGroundBrightness;
	WORD m_nCurrentLowCloudsRed;
	WORD m_nCurrentLowCloudsGreen;
	WORD m_nCurrentLowCloudsBlue;
	WORD m_nCurrentFluffyCloudsBottomRed;
	WORD m_nCurrentFluffyCloudsBottomGreen;
	WORD m_nCurrentFluffyCloudsBottomBlue;
	float m_nCurrentWaterRed;
	float m_nCurrentWaterGreen;
	float m_nCurrentWaterBlue;
	float m_nCurrentWaterAlpha;
	float m_nCurrentColourCorrectRed;
	float m_nCurrentColourCorrectGreen;
	float m_nCurrentColourCorrectBlue;
	float m_nCurrentColourCorrectAlpha;
	float m_nCurrentColourAddRed;//0x88
	float m_nCurrentColourAddGreen;//0x8C
	float m_nCurrentColourAddBlue;//0x90
	float m_nCurrentColourAddAlpha;//0x94
	float m_nCurrentLowCloudsAlpha;//0x98
	DWORD m_nCurrentFluffyCloudsBottomAlpha;//0x9C
	WORD m_nCurrentFluffyCloudsTopAlpha;//0xA0
	char gap_2[2];
	float Illumination;//0xA4
	float Unknown1_0;	};//0xA8
#pragma pack(pop)

igtimecyc* timecyc = (igtimecyc*)0x00B7C4A0;

D3DXVECTOR4 CC1;
D3DXVECTOR4 CC2;
bool screenshot = false;

//Called AFTER the device is reset!
void CustomInitialize(IDirect3DDevice9* pDevice, D3DPRESENT_PARAMETERS* pPresentationParameters)
{
	screen_width = pPresentationParameters->BackBufferWidth;
	screen_height = pPresentationParameters->BackBufferHeight;

	// adjust for weird DirectX texel centering:
    // (otherwise the image will shift slightly each time we blur it)
    float u_adjust = 0.5f / (float)screen_width;
    float v_adjust = 0.5f / (float)screen_height;

	if(FAILED(pD3DDevice->CreateVertexBuffer( 4 * sizeof(QuadVertex), D3DUSAGE_WRITEONLY | D3DUSAGE_DYNAMIC, 0, D3DPOOL_DEFAULT, &m_pVertexBuffer, 0)))
	{
		MessageBox(0,"Could not create post vertex buffer","Bad Vertex Buffer",0);
	}

	QuadVertex* pBuff = 0;
	if (m_pVertexBuffer)
    {
        if(SUCCEEDED(m_pVertexBuffer->Lock(0, 4 * sizeof(QuadVertex),(void**)&pBuff, 0)))
        {
			//MessageBox(0,"Couldn't lock vertex buffer","ERROR", MB_OK|MB_SETFOREGROUND|MB_TOPMOST);
            //MessageBox(NULL, _T("Couldn't lock buffer!"), _T("ERROR"), MB_OK|MB_SETFOREGROUND|MB_TOPMOST);
            //return hr;
			for (int i = 0; i < 4; ++i)
			{
				pBuff->Position = D3DXVECTOR3((i==0 || i==3) ? -1.0f : 1.0f,
											  (i<2)          ? -1.0f : 1.0f,
											  0.0f);
				pBuff->Tex      = D3DXVECTOR2(((i==0 || i==3) ? 0.0f : 1.0f) + u_adjust,
											  ((i<2)          ? 1.0f : 0.0f) + v_adjust);
				pBuff++;
			}
			m_pVertexBuffer->Unlock();
        }        
    }

	DWORD flags = 0;

	//from 3ds max sdk dox;
	D3DXMACRO macros[2] = {
		{"SABUILD",NULL},
		{NULL,NULL}
	};

	if(FAILED(D3DXCreateEffectFromFile(pD3DDevice,"./post.fx",macros,0,flags,0,&g_pEffect,0)))
	{
		MessageBox(0,"Cannot create effect","Caption",0);
	}

	//find param for screenshot key. This will return the first param with a "SCREENKEY" semantic
	D3DXHANDLE handle_screenkey = g_pEffect->GetParameterBySemantic(0,"SCREENKEY");
	g_pEffect->GetFloat("fFogRangeFixed",&fogConst);
	g_pEffect->GetInt(handle_screenkey,&screenKey);
	//g_pEffect->GetBool("bFixedFog",(BOOL*)&bFixedFog);

	//DWORD usage = D3DUSAGE_RENDERTARGET;
	if(FAILED(pD3DDevice->CreateTexture(screen_width,screen_height,1,(D3DUSAGE_RENDERTARGET),D3DFMT_A8R8G8B8,D3DPOOL_DEFAULT,&sceneTex,0)))
	{
		MessageBox(0,"Cannot create scene texture for post process","Scene texture create",0);
	}
	if(FAILED(pD3DDevice->CreateTexture(screen_width/4,screen_height/4,1,(D3DUSAGE_RENDERTARGET),D3DFMT_A8R8G8B8,D3DPOOL_DEFAULT,&sceneTexDown25,0)))
	{
		MessageBox(0,"Cannot create scene downsample for post process","Scene downsample create",0);
	}
}

void customPost()
{
	D3DXMATRIX matWorld;
	D3DXMATRIX matView;
    D3DXMATRIX matProj;
    D3DXMATRIX matViewProj;
    D3DXMATRIX matWorldViewProj;
	char screenfilenamebuf[256];
	
	//check for screenshot keypress here
	if(GetAsyncKeyState(screenKey))
	{
		//if screenshot, generate filenames to use when the file is written to disk
		screenshot = true;
	}

	D3DXVECTOR3 const vEyePt    = D3DXVECTOR3( 0.0f, 0.0f, -5.0f );
	D3DXVECTOR3 const vLookatPt = D3DXVECTOR3( 0.0f, 0.0f, 0.0f );
	D3DXVECTOR3 const vUp       = D3DXVECTOR3( 0.0f, 1.0f, 0.0f );

	// Set World, View, Projection, and combination matrices.
    D3DXMatrixLookAtLH(&matView, &vEyePt, &vLookatPt, &vUp);
    D3DXMatrixOrthoLH(&matProj, 4.0f, 4.0f, 0.2f, 20.0f);
    D3DXMatrixMultiply(&matViewProj, &matView, &matProj);

    // draw a single quad to texture: the quad covers the whole "screen" exactly
    D3DXMatrixScaling(&matWorld, 2.0f, 2.0f, 1.0f);
	
	// draw quad in upper left corner: original texture
	//D3DXMatrixTranslation(&matWorld, -1.0f, 1.0f, 0.0f);
	//D3DXMatrixTranslation(&matWorld, 0.0f, 0.0f, 0.0f);
    
	D3DXMatrixMultiply(&matWorldViewProj, &matWorld, &matViewProj);
    D3DXMatrixTranspose(&matWorldViewProj, &matWorldViewProj);

	//blit current RT surface to scene texture
	IDirect3DSurface9* currentRT = 0;
	if(SUCCEEDED(pD3DDevice->GetRenderTarget(0,&currentRT)))
	{
		//Get the top level surface for my RT texture. They're the same dimensions, no filtering necessary
		IDirect3DSurface9* texsurf = 0;
		if(SUCCEEDED(sceneTex->GetSurfaceLevel(0,&texsurf))) {
			if(SUCCEEDED(pD3DDevice->StretchRect(currentRT,0,texsurf,0,D3DTEXF_NONE))) {
				if(screenshot) {
					sprintf(screenfilenamebuf,"./orig_%d.bmp",screenCount);
					D3DXSaveSurfaceToFile(screenfilenamebuf,D3DXIFF_BMP,currentRT,0,0);
					ZeroMemory(&screenfilenamebuf,sizeof(char[256]));
				}
			}
			texsurf->Release();
		}
		currentRT->Release();

		//Now copy the the fullsize texture to the downsample
		IDirect3DSurface9* texdownsurf = 0;
		if(SUCCEEDED(sceneTex->GetSurfaceLevel(0,&texsurf)))
		{
			if(SUCCEEDED(sceneTexDown25->GetSurfaceLevel(0,&texdownsurf)))
			{
				if(SUCCEEDED(pD3DDevice->StretchRect(texsurf,0,texdownsurf,0,D3DTEXF_LINEAR)))
				{
				}
				texdownsurf->Release();
			}
			texsurf->Release();
		}
	}

	CC1.x = timecyc->m_nCurrentColourAddRed * UBYTERECIP;//No longer dividing by 255! / 255.0f
	CC1.y = timecyc->m_nCurrentColourAddGreen * UBYTERECIP;
	CC1.z = timecyc->m_nCurrentColourAddBlue * UBYTERECIP;
	CC1.w = timecyc->m_nCurrentColourAddAlpha * UBYTERECIP;

	CC2.x = timecyc->m_nCurrentColourCorrectRed * UBYTERECIP;
	CC2.y = timecyc->m_nCurrentColourCorrectGreen * UBYTERECIP;
	CC2.z = timecyc->m_nCurrentColourCorrectBlue * UBYTERECIP;
	CC2.w = timecyc->m_nCurrentColourCorrectAlpha * UBYTERECIP;
 
	g_pEffect->SetTechnique("Simple");
	UINT passes;
	if(SUCCEEDED(g_pEffect->Begin(&passes,0)))
	{
		//g_pEffect->GetPassByName
		if(SUCCEEDED(g_pEffect->BeginPass(0)))
		{
			//BlurAmount = 1.0f;//(float)(*gameBlur)/255;
			g_pEffect->SetMatrix("WorldViewProj", &matWorldViewProj);
			g_pEffect->SetFloat("lerpAmnt", BlurAmount);
			g_pEffect->SetVector("cc1",&CC1);
			g_pEffect->SetVector("cc2",&CC2);
			g_pEffect->SetTexture("SceneMap", sceneTex);
			g_pEffect->SetTexture("DownsampleMap", sceneTexDown25);
			g_pEffect->CommitChanges();

			DWORD oldfvf;//ingame fullscreen quads will be fucked if this isn't restored properly
			pD3DDevice->GetFVF(&oldfvf);
			pD3DDevice->SetFVF(D3DFVF_XYZ | D3DFVF_TEX1);
			pD3DDevice->SetStreamSource(0, m_pVertexBuffer, 0, sizeof(QuadVertex));
			pD3DDevice->DrawPrimitive(D3DPT_TRIANGLEFAN, 0, 2);
			pD3DDevice->SetFVF(oldfvf);
			g_pEffect->EndPass();
		}
		g_pEffect->End();
	}

	if(screenshot){
		//D3DXSaveTextureToFile("./corrected.bmp",D3DXIFF_BMP,sceneTex,0);
		sprintf(screenfilenamebuf,"./corrected_%d.bmp",screenCount);
		D3DXSaveSurfaceToFile(screenfilenamebuf,D3DXIFF_BMP,currentRT,0,0);
		ZeroMemory(&screenfilenamebuf,sizeof(char[256]));
		screenCount++;
	}
	
	//Don't dump screenshots every frame!
	screenshot = false;
}

void patch1_func()
{
	typedef void (*funcPtr)();
	funcPtr patched_orig = (funcPtr)0x007046E0;

	customPost();

	/*
	if(GetAsyncKeyState(VK_F7))
		customPost();
	else
		patched_orig();
		*/
}

DWORD* patch2_func(DWORD* raster, signed long x, signed long y)
{
	typedef DWORD* (*funcPtr)(DWORD*, signed long, signed long);
	funcPtr patched_orig = (funcPtr)0x007FAF50;//rwrasterrender

	//customPost();

	//return patched_orig(raster,x,y);
	return raster;
}

void CustomRender(IDirect3DDevice9* pDevice)
{
	if(!runonce)
	{
		//this stuff only needs to be done one time - calling it at Present should ensure that the game is loaded, and Rw is ready to use

		//memory patches start
		DWORD oldProt;
		VirtualProtect((LPVOID)0x401000, 0x4A3000, PAGE_EXECUTE_READWRITE, &oldProt);

		//patches!
		DWORD* patch1 = (DWORD*)0x0053E228;
		*patch1 = (DWORD)&patch1_func - (DWORD)(patch1 + 1);

		//DWORD* patch2 = (DWORD*)0x00704722;
		//*patch2 = (DWORD)&patch2_func - (DWORD)(patch2 + 1);

		//done with patches
		VirtualProtect((LPVOID)0x401000, 0x4A3000, oldProt,0);

		runonce = true;
	}
}

//Called BEFORE the device is reset! Best of OnLostDevice ?
void CustomReset()
{
	//g_pEffect->OnLostDevice
	//SAFE_LOST(g_pEffect);
	SAFE_RELEASE(g_pEffect);
	SAFE_RELEASE(sceneTex);
	SAFE_RELEASE(m_pVertexBuffer);
	SAFE_RELEASE(sceneTexDown25);
}

void CustomFree()
{
	//SAFE_RELEASE(pSpeedoTex);		// Release speedometer texture
	//SAFE_RELEASE(g_pVertDeclPP);
	SAFE_RELEASE(g_pEffect);
	SAFE_RELEASE(sceneTex);
	SAFE_RELEASE(m_pVertexBuffer);
	SAFE_RELEASE(sceneTexDown25);
}